> ## Documentation Index
> Fetch the complete documentation index at: https://apidocs.specurate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Plan



## OpenAPI

````yaml /openapi.json put /v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan
openapi: 3.1.0
info:
  title: Specurate API
  description: ''
  version: 1.0.0
  contact: {}
servers:
  - url: https://app.specurate.com/api
    description: API Server
security: []
tags: []
paths:
  /v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan:
    put:
      tags:
        - Project Budgets
      summary: Update Plan
      operationId: ProjectBudgetsController_updatePlan_v1
      parameters:
        - name: workspaceId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d{0,18}$
        - name: projectId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d{0,18}$
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateProjectBudgetPlanDto'
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectBudgetResponseDto'
      security:
        - bearer: []
components:
  schemas:
    UpdateProjectBudgetPlanDto:
      type: object
      properties:
        version:
          type: integer
          minimum: 0
          maximum: 9007199254740991
        draft:
          type: object
          properties:
            method:
              type: string
              enum:
                - manual
                - area_rates
            manualCeiling:
              type:
                - string
                - 'null'
            targetMarginPct:
              type:
                - string
                - 'null'
            contingencyPct:
              type:
                - string
                - 'null'
          additionalProperties: false
        appliedTemplateId:
          anyOf:
            - type: string
              pattern: ^[1-9]\d{0,18}$
            - type: 'null'
        categories:
          type: array
          items:
            type: object
            properties:
              workspaceCategoryId:
                type: string
                pattern: ^[1-9]\d{0,18}$
              allocation:
                anyOf:
                  - oneOf:
                      - type: object
                        properties:
                          mode:
                            type: string
                            enum:
                              - percent
                          value:
                            type: string
                        required:
                          - mode
                          - value
                        additionalProperties: false
                      - type: object
                        properties:
                          mode:
                            type: string
                            enum:
                              - amount
                          value:
                            type: string
                        required:
                          - mode
                          - value
                        additionalProperties: false
                  - type: 'null'
              softCostDefaults:
                type: object
                propertyNames:
                  type: string
                  pattern: ^[1-9]\d{0,18}$
                additionalProperties:
                  type: string
                  pattern: ^\d{1,12}(?:\.\d{1,6})?$
              defaultMarkupPct:
                type:
                  - string
                  - 'null'
            required:
              - workspaceCategoryId
              - allocation
              - defaultMarkupPct
            additionalProperties: false
      required:
        - version
      additionalProperties: false
    ProjectBudgetResponseDto:
      type: object
      properties:
        draft:
          $ref: '#/components/schemas/ProjectBudgetDraftResponseDto'
        derived:
          $ref: '#/components/schemas/ProjectBudgetDerivedResponseDto'
        areas:
          type: array
          items:
            $ref: '#/components/schemas/ProjectBudgetAreaResponseDto'
        structureVersion:
          type: number
        categories:
          type: array
          items:
            $ref: '#/components/schemas/ProjectBudgetCategoryResponseDto'
        segments:
          type: array
          items:
            $ref: '#/components/schemas/ProjectBudgetSegmentResponseDto'
        departments:
          type: array
          items:
            $ref: '#/components/schemas/ProjectBudgetDepartmentResponseDto'
        latestVersion:
          anyOf:
            - $ref: '#/components/schemas/ProjectBudgetLatestVersionResponseDto'
            - type: 'null'
        hasUnreleasedChanges:
          type: boolean
        releaseWarnings:
          type: array
          items:
            type: string
            enum:
              - CEILING_MISSING
              - AREA_INPUTS_MISSING
              - BUDGET_SHORTFALL
              - OVER_ALLOCATED
        capabilities:
          $ref: '#/components/schemas/ProjectBudgetCapabilitiesResponseDto'
      required:
        - draft
        - derived
        - areas
        - structureVersion
        - categories
        - segments
        - departments
        - latestVersion
        - hasUnreleasedChanges
        - releaseWarnings
        - capabilities
    ProjectBudgetDraftResponseDto:
      type: object
      properties:
        softCostAllocations:
          type: object
          additionalProperties:
            type: string
        version:
          type: number
        method:
          type: string
          enum:
            - manual
            - area_rates
        manualCeiling:
          type:
            - string
            - 'null'
        targetMarginPct:
          type:
            - string
            - 'null'
        contingencyPct:
          type:
            - string
            - 'null'
        appliedTemplate:
          anyOf:
            - $ref: '#/components/schemas/ProjectBudgetAppliedTemplateResponseDto'
            - type: 'null'
      required:
        - version
        - method
        - appliedTemplate
    ProjectBudgetDerivedResponseDto:
      type: object
      properties:
        softCostBudgets:
          type: object
          additionalProperties:
            anyOf:
              - type: string
              - type: 'null'
        ceiling:
          type:
            - string
            - 'null'
        profit:
          type:
            - string
            - 'null'
        envelope:
          type:
            - string
            - 'null'
        contingency:
          type:
            - string
            - 'null'
        hard:
          type:
            - string
            - 'null'
        allocated:
          type:
            - string
            - 'null'
        unallocated:
          type:
            - string
            - 'null'
        overAllocated:
          type: boolean
        areaInputsMissing:
          type: boolean
        softCostBudgetTotal:
          type:
            - string
            - 'null'
    ProjectBudgetAreaResponseDto:
      type: object
      properties:
        areaId:
          type: string
        name:
          type: string
        depth:
          type: number
        isLeaf:
          type: boolean
        effectiveInstanceCount:
          type: number
        squareArea:
          type:
            - string
            - 'null'
        rate:
          type:
            - string
            - 'null'
        manualAmount:
          type:
            - string
            - 'null'
        own:
          type:
            - string
            - 'null'
        total:
          type: string
        inputMissing:
          type: boolean
      required:
        - areaId
        - name
        - depth
        - isLeaf
        - effectiveInstanceCount
        - squareArea
    ProjectBudgetCategoryResponseDto:
      type: object
      properties:
        softCostDefaults:
          type: object
          additionalProperties:
            type: string
        workspaceCategoryId:
          type: string
        name:
          type: string
        active:
          type: boolean
        segmentKey:
          type:
            - string
            - 'null'
        segmentName:
          type:
            - string
            - 'null'
        departmentId:
          type:
            - string
            - 'null'
        departmentName:
          type:
            - string
            - 'null'
        rule:
          anyOf:
            - $ref: '#/components/schemas/ProjectBudgetCategoryRuleResponseDto'
            - type: 'null'
        allocation:
          type:
            - string
            - 'null'
        sharePct:
          type:
            - string
            - 'null'
        defaultMarkupPct:
          type:
            - string
            - 'null'
        effectiveMarkupPct:
          type: string
        equivalentMarginPct:
          type: string
        markupFromProject:
          type: boolean
        sellAllocation:
          type:
            - string
            - 'null'
        itemCount:
          type: number
      required:
        - workspaceCategoryId
        - name
        - active
        - segmentKey
        - segmentName
        - departmentId
        - departmentName
        - itemCount
    ProjectBudgetSegmentResponseDto:
      type: object
      properties:
        key:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        allocated:
          type: string
      required:
        - key
        - name
    ProjectBudgetDepartmentResponseDto:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        segmentKey:
          type: string
        allocated:
          type: string
      required:
        - id
        - name
        - segmentKey
    ProjectBudgetLatestVersionResponseDto:
      type: object
      properties:
        id:
          type: string
        number:
          type: number
        note:
          type:
            - string
            - 'null'
        releasedAt:
          format: date-time
          type: string
        releasedBy:
          $ref: '#/components/schemas/ProjectBudgetVersionActorResponseDto'
        baseDraftVersion:
          type: number
        baseStructureVersion:
          type: number
      required:
        - id
        - number
        - note
        - releasedAt
        - releasedBy
        - baseDraftVersion
        - baseStructureVersion
    ProjectBudgetCapabilitiesResponseDto:
      type: object
      properties:
        softCosts:
          type: boolean
        itemizedBudget:
          type: boolean
        taxInclusive:
          type: boolean
        allocationTemplates:
          type: boolean
      required:
        - softCosts
        - itemizedBudget
        - taxInclusive
        - allocationTemplates
    ProjectBudgetAppliedTemplateResponseDto:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        differs:
          type: boolean
      required:
        - id
        - name
        - differs
    ProjectBudgetCategoryRuleResponseDto:
      type: object
      properties:
        mode:
          type: string
          enum:
            - percent
            - amount
        value:
          type: string
      required:
        - mode
        - value
    ProjectBudgetVersionActorResponseDto:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
      required:
        - id
        - name
  securitySchemes:
    bearer:
      scheme: bearer
      bearerFormat: JWT
      type: http

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.